## plastimatch 1.10.0+dfsg.1

=== Testing/CMakeLists.txt ===
project (PLM_Testing)

## -------------------------------------------------------------------------
## TODO: create targets like "make check plm-reg-bsp-a"
## http://stackoverflow.com/questions/733475/cmake-ctest-make-test-doesnt-build-tests
## -------------------------------------------------------------------------

## -------------------------------------------------------------------------
## Note on test dependencies.  Some versions of cmake (e.g. Windows cmake 
## version 2.8.2) have a bug where the dependency graph is created 
## incorrectly.  Specifically, if B depends on A, and C depends on 
## both A and B, the graph will be generated incorrectly.  
## -------------------------------------------------------------------------

## -------------------------------------------------------------------------
## Test and data download options
## -------------------------------------------------------------------------
option (PLM_REDUCED_TESTS 
  "Run fewer tests (used when debugging tests)" OFF)
option (PLM_DOWNLOAD_TEST_DATA
  "Additional testing data (download from internet)" OFF)

##-----------------------------------------------------------------------------
## Configure test input files
##-----------------------------------------------------------------------------
set (CONFIG_FILE_LIST
  "plm-bsp-mse-c.txt"
  "plm-bsp-mse-g.txt"
  "plm-bsp-mse-h.txt"
  "plm-bsp-mse-i.txt"
  "plm-bsp-mse-k.txt"
  "plm-bsp-mse-l.txt"
  "plm-bsp-mse-o.txt"
  "plm-bsp-mse-p.txt"
  "plm-bsp-mse-q.txt"
  "plm-bsp-mse-r.txt"
  "plm-bsp-mi-c.txt"
  "plm-bsp-mi-c-2.txt"
  "plm-bsp-mi-k.txt"
  "plm-bsp-gm-k.txt"
  "plm-bsp-dmap-k.txt"
  "plm-bsp-sm-multi-a.txt"
  "plm-bsp-cuda.txt"
  "plm-bsp-rect.txt"
  "plm-bsp-resume.txt"
  "plm-bsp-logfile.txt"
  "plm-bsp-dcos-a.txt"
  "plm-bsp-dcos-b.txt"
  "plm-bsp-dcos-c.txt"
  "plm-bsp-dcos-d.txt"
  "plm-bsp-dcos-e.txt"
  "plm-bsp-dcos-f.txt"
  "plm-bsp-landmark-a.txt"
  "plm-bsp-landmark-b.txt"
  "plm-bsp-landmark-c.txt"
  "plm-bsp-landmark-d.txt"
  "plm-bsp-landmark-e.txt"
  "plm-bsp-double.txt"
  "plm-bsp-regularize-none.txt"
  "plm-bsp-regularize-analytic.txt"
  "plm-bsp-regularize-numeric.txt"
  "plm-reg-align-center.txt"
  "plm-reg-itk-demons.txt"
  "plm-reg-itk-demons-diff.txt"
  "plm-reg-itk-demons-logd.txt"
  "plm-reg-itk-demons-sym-logd.txt"
  "plm-reg-itk-translation.txt"
  "plm-reg-roi-a.txt"
  "plm-reg-roi-b.txt"
  "plm-reg-roi-c.txt"
  "plm-reg-roi-d.txt"
  "plm-reg-roi-e.txt"
  "plm-reg-stiffness-a.txt"
  "plm-reg-multi-a.txt"
  "plm-reg-multi-b.txt"
  "plm-reg-dv-itk-translation.txt"
  "plm-reg-itk-rigid-a.txt"
  "plm-reg-itk-rigid-b.txt"
  "plm-reg-itk-similarity.txt"
  "plm-reg-itk-bspline.txt"
  "plm-reg-process-a.txt"
  "plm-reg-trans-a.txt"
  "plm-reg-trans-b.txt"
  "plm-reg-trans-mi-a.txt"
  "plm-reg-autores-a.txt"
  "plm-reg-autores-b.txt"
  "plm-reg-gw-a.txt"
  "plm-reg-point-dmap-a.txt"
  "proton-dose-1.txt"
  "proton-dose-2.txt"
  "proton-dose-4a.txt"
  "proton-dose-4d.txt"
  "proton-dose-5a.txt"
  "proton-dose-5d.txt"
  "proton-dose-6a.txt"
  "proton-dose-7a.txt"
  "proton-dose-8d.txt"
  "speedtest-a.txt"
  "wed-a.txt"
  "wed-b.txt"
  "wed-c.txt"
)
foreach (CONFIG_FILE ${CONFIG_FILE_LIST})
    string (REGEX REPLACE "\\.txt$" "" PLM_TEST_NAME ${CONFIG_FILE})
    configure_file ("${PLM_TESTING_DATA_DIR}/${CONFIG_FILE}"
	"${PLM_BUILD_TESTING_DIR}/${CONFIG_FILE}"
	@ONLY)
endforeach ()

## -------------------------------------------------------------------------
## Testing macros
## -------------------------------------------------------------------------
macro (plmtest_check_interval 
    test_name stdout_file regex_string lower_thresh upper_thresh)
  string (REPLACE "\\" "\\\\" regex_escaped "${regex_string}")
  add_test (${test_name}
    ${CMAKE_COMMAND} 
    "-DINFILE=${stdout_file}"
    "-DREGEX=${regex_escaped}"
    "-DLOWER_THRESH=${lower_thresh}"
    "-DUPPER_THRESH=${upper_thresh}"
    -P "${PLM_TESTING_SOURCE_DIR}/PlmCheckInterval.cmake"
    )
endmacro ()

macro (plmtest_check_string
    test_name stdout_file regex_string match_string)
  string (REPLACE "\\" "\\\\" regex_escaped "${regex_string}")
  add_test (${test_name}
    ${CMAKE_COMMAND} 
    "-DINFILE=${stdout_file}"
    "-DREGEX=${regex_escaped}"
    "-DMATCH_STRING=${match_string}"
    -P "${PLM_TESTING_SOURCE_DIR}/PlmCheckString.cmake"
    )
endmacro ()

macro (plmtest_debug test_name stdout_file stderr_file)
  add_test (${test_name}
    ${CMAKE_COMMAND} 
    "-DSTDOUT_FILE=${stdout_file}"
    "-DSTDERR_FILE=${stderr_file}"
    -P "${PLM_TESTING_SOURCE_DIR}/PlmTestDebug.cmake"
    )
endmacro ()

## -------------------------------------------------------------------------
## Download data sets
## -------------------------------------------------------------------------
macro (plm_download_and_extract DOWNLOAD_URL DOWNLOAD_FILENAME DOWNLOAD_DIR)
  if (NOT IS_DIRECTORY "${PLM_TESTING_DOWNLOAD_DATA_DIR}")
    file (MAKE_DIRECTORY "${PLM_TESTING_DOWNLOAD_DATA_DIR}")
  endif ()
  set (download_retries 3)
  while (NOT EXISTS ${DOWNLOAD_FILENAME} AND download_retries)
    message (STATUS "Downloading test data: ${DOWNLOAD_FILENAME}")
    file (DOWNLOAD "${DOWNLOAD_URL}" "${DOWNLOAD_FILENAME}"
      STATUS download_status)
    message (STATUS "Download status[${download_retries}]: ${download_status}")
    list (GET download_status 0 dl_status)
    if (dl_status)
      math (EXPR download_retries "${download_retries}-1")
    endif ()
  endwhile ()
  if (NOT EXISTS ${DOWNLOAD_DIR})
    message (STATUS "Untarring test data: ${DOWNLOAD_FILENAME}")
    execute_process (
      COMMAND 
      ${CMAKE_COMMAND} "-E" "tar" "xvzf" "${DOWNLOAD_FILENAME}"
      WORKING_DIRECTORY ${PLM_BUILD_TESTING_DIR}
      RESULT_VARIABLE untar_result
      OUTPUT_VARIABLE untar_output
      ERROR_VARIABLE untar_error)
    message (STATUS "Untar command returned: ${untar_result}\n${untar_output}\n${untar_error}")
  endif ()
endmacro ()

if (PLM_DOWNLOAD_TEST_DATA)

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-33-structures.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-33-structures.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-33-structures")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-aw-4.4-foot.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-aw-4.4-foot.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-aw-4.4-foot")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-corvus-6.2.2.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-corvus-6.2.2.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-corvus-6.2.2")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-pinnacle3-8.2g-rando.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-pinnacle3-8.2g-rando.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-pinnacle3-8.2g-rando")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-xio-4.33.02-chest-phantom.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-xio-4.33.02-chest-phantom.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-xio-4.33.02-chest-phantom")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-xio-4.60-irregular-spacing.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-xio-4.60-irregular-spacing.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-xio-4.60-irregular-spacing")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/headphantom.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/headphantom.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/headphantom")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/rtog-corvus-6.2.2.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/rtog-corvus-6.2.2.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/rtog-corvus-6.2.2")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/varian-catphan-subset.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/varian-catphan-subset.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/varian-catphan-subset")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/xio-4.33.02-chest-phantom.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/xio-4.33.02-chest-phantom.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/xio-4.33.02-chest-phantom")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/xio-4.60-irregular-spacing.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/xio-4.60-irregular-spacing.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/xio-4.60-irregular-spacing")

endif ()

## -------------------------------------------------------------------------
## Custom test command
## -------------------------------------------------------------------------
add_custom_target (speedtest
  ${CMAKE_COMMAND} 
  -DPLM_PLASTIMATCH_PATH="${PLM_PLASTIMATCH_PATH}"
  -DPLM_BUILD_TESTING_DIR="${PLM_BUILD_TESTING_DIR}"
  -P "${PLM_TESTING_SOURCE_DIR}/PlmSpeedTest.cmake"
  )

## -------------------------------------------------------------------------
## Test cases
## -------------------------------------------------------------------------
## Create synthetic images
##   black-1           All black, slightly different geometry
##   cyl-1             UChar cylinder full height
##   cyl-mask-2        Mask for cyl-2
##   cyl-2             UChar cylinder masked to one z extent
##   cyl-mask-3        Mask for cyl-3
##   cyl-3             UChar cylinder masked to different z extent
##   donut-1           Centered donut
##   donut-2           Centered donut mask (0s and 1s)
##   gabor-xx          Fibonacci Gabor
##   gauss-1           Centered gauss
##   gauss-2           Off-center gauss
##   gauss-3           Inverted gauss
##   gauss-4           Gauss with inverted pixel spacing
##   gauss-5           Even more off-center gauss
##   gauss-6           Off-center gauss, in off-center world coordinates
##   gauss-7           Off-center gauss with wider sigma
##   gauss-ushort-1    Centered gauss, ushort
##   gauss-ushort-2    Off-center gauss, ushort
##   lung-1            Synthetic lung, tumor position 0
##   lung-2            Synthetic lung, tumor position -5
##   gw-lung-a         Synthetic lung, tumor position -5, in gw dir
##   gw-lung-b         Synthetic lung, tumor position 0, in gw dir
##   gw-lung-c         Synthetic lung, tumor position +5, in gw dir
##   pat-1             DICOM data with patient name and patient id
##   ptv-1             rect PTV target for dose calculation
##   ptv-2             rect PTV target for dose calculation, smaller geometry
##   rect-1            Inverted rect, centered
##   rect-2            Standard rect, off-center
##   rect-3            Standard rect, centered
##   rect-4            Uchar rect, centered
##   rect-5            Standard rect, centered, direction cosines alt-1
##   rect-6            Standard rect, centered, direction cosines alt-2
##   rect-7            Standard rect, centered, direction cosines alt-3
##   rect-8            Uchar rect, off-center
##   rect-9            Uchar rect, centered, higher resolution
##   rect-10-roi-1
##   rect-10-roi-2
##   rect-10
##   rect-11
##   rect-11-roi
##   rect-12           Small rect, bg=0, fg=10
##   rect-13           Small rect, bg=0, fg=11
##   rect-14           Small, off-center rect, bg=0, fg=10
##   rect-15           Standard rect, slicer direction cosines
##   rect-16           Off-center rect, slicer direction cosines
##   rect-17           Water phantom, resolution 5x5x5, for dose calculation
##   rect-18	       Water phantom, very low resolution 20x20, dose calc.
##   rect-19	       Standard, but larger rectangle

=== src/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  Welcome to the Plastimatch CMakeLists.txt file
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src)

##-----------------------------------------------------------------------------
##  Add subdirectories
##-----------------------------------------------------------------------------
if (PLM_CONFIG_DEBIAN_BUILD)
  set (PLM_CONFIG_ENABLE_FATM OFF)
endif ()

if (PLM_CONFIG_ENABLE_FATM)
  add_subdirectory (fatm)
endif ()

##-----------------------------------------------------------------------------
##  CMake include files
##-----------------------------------------------------------------------------
set (CMAKE_MODULE_PATH "${PLM_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include (PlmMacros)

##-----------------------------------------------------------------------------
##  Processor and OS characteristics
##    32-bit or 64-bit machine
##    Endian-ness
##    Machine precision
##    Processor type
##-----------------------------------------------------------------------------
include (CheckCharSign)
include (CheckEpsilon)
# No need to check this yet.  Doing so may force C++11 compiler flag,
# which causes build error on earlier version of ITK.
#include (CheckNullptr)
include (CheckTypeSize)
include (TestBigEndian)

check_type_size ("unsigned int" CMAKE_SIZEOF_UINT)
check_type_size ("unsigned long" CMAKE_SIZEOF_ULONG)
check_type_size ("unsigned long long" CMAKE_SIZEOF_ULONGLONG)
check_type_size ("size_t" CMAKE_SIZEOF_SIZE_T)
if (NOT APPLE)
  if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    set (MACHINE_IS_32_BIT TRUE)
    set (MACHINE_IS_64_BIT FALSE)
    message (STATUS "Machine is 32-bit")
  else ()
    set (MACHINE_IS_32_BIT FALSE)
    set (MACHINE_IS_64_BIT TRUE)
    message (STATUS "Machine is 64-bit")
  endif ()
endif ()

test_big_endian (PLM_BIG_ENDIAN)
check_epsilon (MACHINE_EPS)
check_char_sign (CHAR_SIGN)
message (STATUS "Checking host processor: ${CMAKE_HOST_SYSTEM_PROCESSOR}")
message (STATUS "Checking target processor: ${CMAKE_SYSTEM_PROCESSOR}")
message (STATUS "Checking epsilon: ${MACHINE_EPS}")
message (STATUS "Checking sign of char: ${CHAR_SIGN}")

include (CheckIncludeFiles)
check_include_files ("stdint.h" HAVE_STDINT_H)
check_include_files ("sys/stat.h" HAVE_SYS_STAT_H)

##-----------------------------------------------------------------------------
##  DCMTK
##-----------------------------------------------------------------------------
find_package (DCMTK)
set (PLM_DCM_USE_DCMTK 0)
if (DCMTK_FOUND)
  set (PLM_DCM_USE_DCMTK 1)
endif ()

##-----------------------------------------------------------------------------
##  dlib
##-----------------------------------------------------------------------------
if (PLM_PREFER_SYSTEM_DLIB)
  # Use this version if you want to use the internal cmake find.
  # The internal version has issue finding the correct BLAS library
  # for Debian, so we prefer Debian version.
  # find_package (Dlib)

  # A previous version of the Debian cmake find was broken in a way that 
  # could be worked around by setting dlib_BINARY_DIR.  However, modern
  # dlibConfig.cmake scripts do not have this problem.
  ##  set (dlib_BINARY_DIR 1)
  find_package (dlib QUIET)
endif ()
set (DLIB_HAVE_LIBRARY FALSE)
if (dlib_FOUND)
  set (DLIB_INCLUDE_DIR ${dlib_INCLUDE_DIR})
  #set (DLIB_LIBRARIES ${dlib_LIBRARIES})
  set (DLIB_LIBRARIES dlib::dlib)
  set (DLIB_FOUND TRUE)
  if (DLIB_LIBRARIES)
    set (DLIB_HAVE_LIBRARY TRUE)
  endif ()
else ()
  set (DLIB_INCLUDE_DIR "${PLM_SOURCE_DIR}/libs/dlib-19.1")
  set (DLIB_LIBRARIES "")
endif ()

##-----------------------------------------------------------------------------
##  ransac
##-----------------------------------------------------------------------------
set (RANSAC_INCLUDE_DIRS
  "${PLM_SOURCE_DIR}/libs/ransac"
  "${PLM_SOURCE_DIR}/libs/ransac/Common")

##-----------------------------------------------------------------------------
##  ITK
##-----------------------------------------------------------------------------
if (PLM_USING_SUPERBUILD)
  find_package (ITK REQUIRED
    PATHS "/usr/lib64/cmake/InsightToolkit")
  include (HandleITK)
  include (HandleVXL)
endif ()

##-----------------------------------------------------------------------------
##  Hack for superbuild
##-----------------------------------------------------------------------------
#link_directories (${PLM_BINARY_DIR})

##-----------------------------------------------------------------------------
##  Libraries
##-----------------------------------------------------------------------------
set (PLASTIMATCH_LIBS
  plmclp
#  plmscript
  plmsegment
  plmregister
  plmreconstruct
  plmdose
  plmutil
  plmbase
  plmsys
  ${ITK_LIBRARIES}
  devillard
  nkidecompress
#  lua
  ${MATH_LIB}
  )

#if (CUDA_FOUND AND NOT PLM_USE_GPU_PLUGINS)
if (CUDA_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} plmcuda)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} plmutilcuda)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} plmreconstructcuda)

##  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} plmregistercuda)
endif ()

if (DCMTK_FOUND)
  if (TARGET DCMTK::dcmjpeg)
    set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} DCMTK::dcmjpeg)
  else ()
    set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${DCMTK_LIBRARIES})
  endif ()
endif ()

if (DLIB_LIBRARIES)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${DLIB_LIBRARIES})
endif ()

if (FFTW_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${FFTW_LIBRARIES})
endif ()

if (LIBDL_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} dl)
endif ()

if (nlopt_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${nlopt_LIBRARIES})
endif ()

if (OpenCL_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} plmopencl)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${OpenCL_LIBRARIES})
endif ()

if (OPENMP_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${OPENMP_LIBRARIES})
endif ()

if (SPECFUN_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} specfun)
endif ()

### Let QT applications add this themselves
#if (QT4_FOUND)
#  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${QT_LIBRARIES})
#endif ()

##-----------------------------------------------------------------------------
##  Linker flags
##-----------------------------------------------------------------------------
set (PLASTIMATCH_LDFLAGS "${OPENMP_LDFLAGS}")
if (PLM_USE_GPU_PLUGINS AND WIN32 AND NOT CYGWIN AND NOT MINGW)
  set (PLASTIMATCH_LDFLAGS
 "${PLASTIMATCH_LDFLAGS} /DELAYLOAD:plmutilcuda.dll /DELAYLOAD:plmregistercuda.dll /DELAYLOAD:plmreconstructcuda.dll")
endif ()

if (PLM_CONFIG_NOMANIFEST AND WIN32)
  set (PLASTIMATCH_LDFLAGS "${PLASTIMATCH_LDFLAGS} /MANIFEST:NO")
endif ()

##-----------------------------------------------------------------------------
##  Include directories
##-----------------------------------------------------------------------------

# ITK compatibility shims
if (NOT HAVE_ITK_VECTOR_CD)
  message (STATUS "Appending ${CMAKE_SOURCE_DIR}/libs/itk-5.1.0")
  include_directories (AFTER "${CMAKE_SOURCE_DIR}/libs/itk-5.1.0")
else ()
  message (STATUS "Not appending ${CMAKE_SOURCE_DIR}/libs/itk-5.1.0")
endif ()
if (("${ITK_VERSION}" VERSION_LESS "4.13") OR (NOT ${PLM_PREFER_NEW_ITK_DEMONS}))
  set (PLM_USE_NEW_ITK_DEMONS OFF)
  include_directories (AFTER "${PLM_SOURCE_DIR}/libs/demons_itk_insight")
  include_directories (AFTER ${PLM_SOURCE_DIR}/libs/demons_itk_insight/DiffeomorphicDemons)
  include_directories (AFTER ${PLM_SOURCE_DIR}/libs/demons_itk_insight/FastSymmetricForces)
  include_directories (AFTER ${PLM_SOURCE_DIR}/libs/demons_itk_insight/LOGDomainDemons)
else ()
  set (PLM_USE_NEW_ITK_DEMONS ON)
  include_directories (AFTER "${PLM_SOURCE_DIR}/libs/itk-4.13.2-demons")
  include_directories (AFTER "${PLM_SOURCE_DIR}/libs/LogSymmetricDemons")
endif ()
if ("${ITK_VERSION}" VERSION_LESS "5")
  message (STATUS "Appending ${CMAKE_SOURCE_DIR}/libs/itk-5.1.2")
  include_directories (BEFORE "${PLM_SOURCE_DIR}/libs/itk-5.1.2")
else ()
  message (STATUS "Not appending ${CMAKE_SOURCE_DIR}/libs/itk-5.1.2")
endif ()

include_directories (AFTER ${PLM_SOURCE_DIR}/libs/nSIFT)
include_directories (AFTER ${DLIB_INCLUDE_DIR})
include_directories (AFTER ${libLBFGS_INCLUDE_DIR})
include_directories (AFTER ${MSINTTYPES_INCLUDE_DIR})
include_directories (AFTER ${RANSAC_INCLUDE_DIRS})

if (DCMTK_FOUND)
  include_directories (BEFORE ${DCMTK_INCLUDE_DIRS})
  if (DEFINED DCMTK_CMAKE_INSTALL_LIBDIR)
    link_directories ("${DCMTK_DIR}/${DCMTK_CMAKE_INSTALL_LIBDIR}")
  endif ()
endif ()
if (FFTW_FOUND)
  include_directories (BEFORE ${FFTW_INCLUDE_DIR})
  link_directories (${FFTW_DIR})
endif ()
if (MATLAB_FOUND)
  include_directories (AFTER ${MATLAB_INCLUDE_DIRS})
endif ()
if (nlopt_FOUND)
  include_directories (AFTER ${nlopt_INCLUDE_DIR})
endif ()
if (OpenCL_FOUND)
  include_directories (BEFORE ${OpenCL_INCLUDE_DIRS})
endif ()
#if (QT4_FOUND)
#  if (QT_QTGUI_FOUND)
#    include_directories (AFTER ${QT_QTGUI_INCLUDE_DIR})
#  endif ()
#  if (QT_QTSQL_FOUND)
#    include_directories (AFTER ${QT_QTSQL_INCLUDE_DIR})
#  endif ()
#endif ()
if (RAPIDJSON_FOUND)
    include_directories (AFTER ${RAPIDJSON_INCLUDE_DIR})
endif ()
if (SQLite3_FOUND)
  include_directories (AFTER ${SQLite3_INCLUDE_DIR})
endif ()

##-----------------------------------------------------------------------------
##  CONFIGURE INCLUDE FILES
##-----------------------------------------------------------------------------
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/sys/plm_config.h.in
  ${PLM_BINARY_DIR}/plm_config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/sys/plm_version.h.in
  ${PLM_BINARY_DIR}/plm_version.h)

##-----------------------------------------------------------------------------
## Option to generate .clang_complete for hip Vim users using clang_complete
##-----------------------------------------------------------------------------
if (PLM_CONFIG_CLANG_COMPLETE)
  get_property(inc_dirs DIRECTORY PROPERTY INCLUDE_DIRECTORIES)
  set (file_clang_complete "${CMAKE_SOURCE_DIR}/src/.clang_complete")
  foreach (arg ${inc_dirs})
    set (inc_args "${inc_args} -I${arg}\n")
  endforeach ()
  file (WRITE "${file_clang_complete}" "${inc_args}")
  message (STATUS "Generated ${file_clang_complete}")
endif ()

##-----------------------------------------------------------------------------
##  Do we have prerequisites for viscous code?
##-----------------------------------------------------------------------------
set (PLM_BUILD_VISCOUS FALSE)
if (PLM_CONFIG_ENABLE_VISCOUS
    AND CUDA_FOUND AND CUDA_SDK_ROOT_DIR AND THRUST_FOUND)
  set (PLM_BUILD_VISCOUS TRUE)
endif ()


##  Specify which libraries of plastimatch should be built
##  Support libraries (base, util, opencl, cuda, etc. are not optional)
if (PLM_CONFIG_LIBRARY_BUILD)
else ()
  set (PLMLIB_CONFIG_ENABLE_CLI true)
  set (PLMLIB_CONFIG_ENABLE_CLP true)
  set (PLMLIB_CONFIG_ENABLE_DOSE true)
  set (PLMLIB_CONFIG_ENABLE_QT true)
  set (PLMLIB_CONFIG_ENABLE_RECONSTRUCT true)
  set (PLMLIB_CONFIG_ENABLE_REGISTER true)
#  set (PLMLIB_CONFIG_ENABLE_SCRIPT true)
  set (PLMLIB_CONFIG_ENABLE_SEGMENT true)
  set (PLMLIB_CONFIG_ENABLE_STANDALONE true)
  set (PLMLIB_CONFIG_ENABLE_TEST true)
endif ()

##-----------------------------------------------------------------------------
##  SETUP IMPORTANT LOCATIONS
##-----------------------------------------------------------------------------
# Offer the user the choice of overriding the installation directories
set (PLM_INSTALL_LIB_DIR lib CACHE PATH
  "Installation directory for libraries")
set (PLM_INSTALL_BIN_DIR bin CACHE PATH
  "Installation directory for executables")
set (PLM_INSTALL_INCLUDE_DIR include/plastimatch CACHE PATH
  "Installation directory for header files")
if (WIN32 AND NOT CYGWIN)
  set (DEF_INSTALL_CMAKE_DIR CMake)
else()

=== examples/csharp/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_csharp LANGUAGES CSharp)
cmake_minimum_required(VERSION 3.25)

message (STATUS "CSharp example!")

# Grab all the .cs files created by SWIG
set (PLM_CS_DIR "C:/Users/gcs6/build/x64/plastimatch/csharp")
file(GLOB_RECURSE SWIG_GENERATED_CS_FILES ${PLM_CS_DIR}/*.cs)

add_executable(csharp-example
  csharp-example.cs
  ${SWIG_GENERATED_CS_FILES}
)

find_package (DCMTK REQUIRED)
find_package (ITK REQUIRED)
link_directories ("C:/Users/gcs6/build/x64/plastimatch/Release")
target_link_libraries (csharp-example PUBLIC 
  plmutil-cs plmutil plmbase plmsys)
if (TARGET DCMTK::dcmdata)
  target_link_libraries (csharp-example PUBLIC DCMTK::dcmdata)
else ()
  target_link_libraries (csharp-example PUBLIC dcmdata)
endif ()
target_link_libraries (csharp-example PUBLIC "${ITK_LIBRARIES}")

=== libs/liblbfgs-1.9/CMakeLists.txt ===
project (liblbfgs)

set (LIBLBFGS_LIBRARY_SRC
  lib/lbfgs.c
  lib/arithmetic_ansi.h
  lib/arithmetic_sse_float.h
  lib/arithmetic_sse_double.h
  )
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/include)

plm_add_static_library (lbfgs "${LIBLBFGS_LIBRARY_SRC}" "" "" "")

=== src/base/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_base)

include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
include_directories (AFTER ${NKIDECOMPRESS_INCLUDE_DIR})

##-----------------------------------------------------------------------------
##  SOURCE FILES
##-----------------------------------------------------------------------------
set (PLMBASE_LIBRARY_SRC
  aperture.cxx aperture.h
  astroid_dose.cxx astroid_dose.h
  beam_geometry.cxx beam_geometry.h
  bspline_header.cxx bspline_header.h
  bspline_interpolate.cxx bspline_interpolate.h
  bspline_warp.cxx bspline_warp.h
  bspline_xform.cxx bspline_xform.h
  bspline_xform_legacy.cxx bspline_xform_legacy.h
  clamp.h
  cxt_extract.cxx cxt_extract.h
  cxt_io.cxx cxt_io.h
  dicom_probe.cxx dicom_probe.h
  dicom_util.cxx dicom_util.h
  dicom.dic   # How to make sure this gets installed?
  direction_cosines.cxx direction_cosines.h
  direction_matrices.cxx direction_matrices.h
  exchkeys.cxx
  float_pair_list.cxx float_pair_list.h
  gaussian.cxx gaussian.h
  hnd_io.cxx hnd_io.h
  hnd_io_p.h
  image_stats.cxx image_stats.h
  interpolate.cxx interpolate.h
  interpolate_macros.h
  itkAndConstantToImageFilter.h
  itkClampCastImageFilter.txx itkClampCastImageFilter.h
  itk_bbox.cxx itk_bbox.h
  itk_directions.cxx itk_directions.h
  itk_image.cxx itk_image.h
  itk_image_accumulate.cxx itk_image_accumulate.h
  itk_image_cast.cxx itk_image_cast.h
  itk_image_clone.cxx itk_image_clone.h
#  itk_image_conv.cxx (broken)
  itk_image_create.cxx itk_image_create.h
  itk_image_header_compare.cxx itk_image_header_compare.h
  itk_image_load.txx itk_image_load.h
  itk_image_load_char.cxx
  itk_image_load_double.cxx
  itk_image_load_float.cxx
  itk_image_load_int32.cxx
  itk_image_load_int64.cxx
  itk_image_load_short.cxx
  itk_image_load_uchar.cxx
  itk_image_load_uint32.cxx
  itk_image_load_uint64.cxx
  itk_image_load_ushort.cxx
  itk_image_load_vec.cxx
  itk_image_origin.cxx itk_image_origin.h
  itk_image_region.cxx itk_image_region.h
  itk_image_save.cxx itk_image_save.h
  itk_image_shift_scale.cxx itk_image_shift_scale.h
  itk_image_stats.cxx itk_image_stats.h
  itk_image_type.h
  itk_metadata.cxx itk_metadata.h
  itk_point.h
  itk_pointset.cxx itk_pointset.h
  itk_resample.cxx itk_resample.h
  itk_volume_header.cxx itk_volume_header.h
  itk_warp.cxx itk_warp.h
  make_string.h
  mc_dose.cxx mc_dose.h
  metadata.cxx metadata.h
  mha_io.cxx mha_io.h
  nki_io.cxx nki_io.h
  parameter_parser.cxx parameter_parser.h
  plm_file_format.cxx plm_file_format.h
  plm_image.cxx plm_image.h
  plm_image_p.h
  plm_image_convert.cxx
  plm_image_header.cxx plm_image_header.h
  plm_image_set.cxx plm_image_set.h
  plm_image_type.cxx plm_image_type.h
  plm_itk.h
  plm_uid_prefix.h
  plm_warp.cxx plm_warp.h
  pointset.cxx pointset.h
  pointset_warp.cxx pointset_warp.h
  proj_image.cxx proj_image.h
  proj_image_dir.cxx proj_image_dir.h
  proj_matrix.cxx proj_matrix.h
  proj_volume.cxx proj_volume.h
  pwlut.cxx pwlut.h
  rasterize_slice.cxx rasterize_slice.h
  rasterizer.cxx rasterizer.h
  raw_pointset.cxx raw_pointset.h
  ray_data.h
  ray_trace.h
  ray_trace_callback.h
  ray_trace_probe.cxx
  ray_trace_probe.h
  ray_trace_uniform.cxx
  rpl_volume.cxx rpl_volume.h
  rpl_volume_lut.cxx rpl_volume_lut.h
  rtds_dcmtk.cxx
  rt_study.cxx rt_study.h
  rt_study_p.h
  rt_study_metadata.cxx rt_study_metadata.h
  rtog_io.cxx
  rtss.cxx rtss.h
  rtss_contour.cxx rtss_contour.h
  rtss_roi.cxx rtss_roi.h
  rtplan.cxx rtplan.h
  rtplan_beam.cxx rtplan_beam.h
  rtplan_control_pt.cxx rtplan_control_pt.h
  segmentation.cxx segmentation.h
  slice_extract.cxx slice_extract.h
  slice_list.cxx slice_list.h
  ss_img_extract.cxx ss_img_extract.h
  ss_list_io.cxx ss_list_io.h
  threading.cxx threading.h
  thumbnail.cxx thumbnail.h
  vf.cxx vf.h
  vf_convolve.cxx vf_convolve.h
  vf_jacobian.cxx vf_jacobian.h
  vf_stats.cxx vf_stats.h
  volume.cxx volume.h
  volume_boundary_behavior.cxx volume_boundary_behavior.h
  volume_conv.cxx volume_conv.h
  volume_fill.cxx volume_fill.h
  volume_gaussian.cxx volume_gaussian.h
  volume_grad.cxx volume_grad.h
  volume_header.cxx volume_header.h
  volume_limit.cxx volume_limit.h
  volume_macros.h
  volume_resample.cxx volume_resample.h
  volume_stats.cxx volume_stats.h
  xform.cxx xform.h
  xform_convert.cxx xform_convert.h
  xform_legacy.cxx xform_legacy.h
  xform_point.cxx xform_point.h
  xio_ct.cxx xio_ct.h
  xio_ct_transform.cxx xio_ct_transform.h
  xio_demographic.cxx xio_demographic.h
  xio_dir.cxx xio_dir.h
  xio_dose.cxx xio_dose.h
  xio_patient.cxx xio_patient.h
  xio_plan.cxx xio_plan.h
  xio_structures.cxx xio_structures.h
  xio_studyset.cxx xio_studyset.h
  xpm.cxx xpm.h xpm_p.h
  )

if (PLM_DCM_USE_DCMTK)
  set (PLMBASE_LIBRARY_SRC
    ${PLMBASE_LIBRARY_SRC}
    dcmtk_config.h
    dcmtk_file.cxx dcmtk_file.h
    dcmtk_image.cxx
    dcmtk_metadata.cxx dcmtk_metadata.h
    dcmtk_module.cxx dcmtk_module.h
    dcmtk_rdd.cxx dcmtk_rdd.h
    dcmtk_rtdose.cxx dcmtk_rtdose.h
    dcmtk_rtss.cxx dcmtk_rtss.h
    dcmtk_rtplan.cxx dcmtk_rtplan.h
    dcmtk_rt_study.cxx dcmtk_rt_study.h
    dcmtk_rt_study_p.cxx dcmtk_rt_study_p.h
    dcmtk_series.cxx dcmtk_series.h
    dcmtk_series_map.h
    dcmtk_sro.cxx dcmtk_sro.h
    dcmtk_uid.cxx dcmtk_uid.h
    dcmtk_util.cxx dcmtk_util.h
    )
endif ()

if (PLM_CONFIG_LEGACY_RAY_TRACE_EXACT)
  set (PLMBASE_LIBRARY_SRC
    ${PLMBASE_LIBRARY_SRC}
    ray_trace_exact_legacy.cxx
    )
else ()
  set (PLMBASE_LIBRARY_SRC
    ${PLMBASE_LIBRARY_SRC}
    ray_trace_exact.cxx
    )
endif ()

set (PLMBASE_LIBRARY_HEADERS "")
foreach (ARG ${PLMBASE_LIBRARY_SRC})
  string (REGEX MATCH ".*\\.h$" TMP "${ARG}")
  if (TMP)
    list (APPEND PLMBASE_LIBRARY_HEADERS "${TMP}")
  endif ()
endforeach ()

##-----------------------------------------------------------------------------
##  LIBRARY DEPENDENCIES
##-----------------------------------------------------------------------------
set (PLMBASE_LIBRARY_DEPENDENCIES
  ${ITK_LIBRARIES}
  nkidecompress
  plmsys
  )
if (DCMTK_FOUND)
  if (TARGET DCMTK::dcmdata)
    set (PLMBASE_LIBRARY_DEPENDENCIES
      ${PLMBASE_LIBRARY_DEPENDENCIES}
      DCMTK::dcmdata)
    if (TARGET DCMTK::dcmimgle)
      set (PLMBASE_LIBRARY_DEPENDENCIES
        ${PLMBASE_LIBRARY_DEPENDENCIES}
        DCMTK::dcmimgle)
    endif ()
  else ()
    set (PLMBASE_LIBRARY_DEPENDENCIES
      ${PLMBASE_LIBRARY_DEPENDENCIES}
      ${DCMTK_LIBRARIES})
  endif ()
endif ()

##-----------------------------------------------------------------------------
##  SPECIAL BUILD RULES: OpenMP & SSE2
##-----------------------------------------------------------------------------
if (OPENMP_FOUND)
  set (PLMBASE_LIBRARY_LDFLAGS "${OPENMP_LDFLAGS}")
  set_source_files_properties (bspline_warp.cxx
    PROPERTIES COMPILE_FLAGS ${OPENMP_FLAGS})
  set_source_files_properties (volume_conv.cxx
    PROPERTIES COMPILE_FLAGS ${OPENMP_FLAGS})
endif ()

if (SSE2_FOUND)
  plm_set_sse2_flags (bspline_warp.cxx)
endif ()

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
plm_add_library (
  plmbase
  "${PLMBASE_LIBRARY_SRC}"
  "${PLMBASE_LIBRARY_DEPENDENCIES}"
  "${PLMBASE_LIBRARY_LDFLAGS}"
  "${PLASTIMATCH_INCLUDE_DIRECTORIES}"
  "${PLMBASE_LIBRARY_HEADERS}"
  )

if (SWIG_FOUND)
  set (PLMBASE_SWIG_LIBRARY_SRC
    plm_image.i)
  set_property (SOURCE ${PLMBASE_SWIG_LIBRARY_SRC}
    PROPERTY CPLUSPLUS ON)
  set (CSHARP_OUTPUT_DIR "${PLM_BINARY_DIR}/csharp")
  set (CSHARP_OUTFILE_DIR "${PLM_BINARY_DIR}/csharp-cxx")
  set (PYTHON_OUTPUT_DIR "${PLM_BINARY_DIR}/python")
  set (PYTHON_OUTFILE_DIR "${PLM_BINARY_DIR}/python-cxx")
  if (PLM_CONFIG_ENABLE_CSHARP)
    swig_add_library (plmbase-cs
      TYPE SHARED
      LANGUAGE csharp
      OUTPUT_DIR "${CSHARP_OUTPUT_DIR}"
      OUTFILE_DIR "${CSHARP_OUTFILE_DIR}"
      SOURCES ${PLMBASE_SWIG_LIBRARY_SRC})
    set_property (TARGET plmbase-cs PROPERTY SWIG_INCLUDE_DIRECTORIES "$<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/sys>")
    target_link_libraries (plmbase-cs PUBLIC plmbase)
    if (TARGET DCMTK::dcmdata)
      target_link_libraries (plmbase-cs PUBLIC DCMTK::dcmdata)
    else ()
      target_link_libraries (plmbase-cs PUBLIC dcmdata)
    endif ()
    set_target_properties (plmbase-cs PROPERTIES
      RUNTIME_OUTPUT_DIRECTORY "${CSHARP_OUTPUT_DIR}"
      LIBRARY_OUTPUT_DIRECTORY "${CSHARP_OUTPUT_DIR}"
      ARCHIVE DESTINATION "${PLM_INSTALL_LIB_DIR}"
      PUBLIC_HEADER DESTINATION "${PLM_INSTALL_INCLUDE_DIR}"
      )
  endif ()
  if (PLM_CONFIG_ENABLE_PYTHON)
    find_package(Python3 REQUIRED COMPONENTS Interpreter Development.Module)
    swig_add_library (plmbase_py
      TYPE SHARED
      LANGUAGE python
      OUTPUT_DIR "${PYTHON_OUTPUT_DIR}"
      OUTFILE_DIR "${PYTHON_OUTFILE_DIR}"
      SOURCES ${PLMBASE_SWIG_LIBRARY_SRC})
    set_property (TARGET plmbase_py PROPERTY SWIG_INCLUDE_DIRECTORIES "$<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/sys>")
    target_include_directories (plmbase_py PUBLIC ${Python3_INCLUDE_DIRS})
    target_link_libraries (plmbase_py PUBLIC plmbase)
    if (TARGET DCMTK::dcmdata)
      target_link_libraries (plmbase_py PUBLIC DCMTK::dcmdata)
    else ()
      target_link_libraries (plmbase_py PUBLIC dcmdata)
    endif ()
    set_target_properties (plmbase_py PROPERTIES
      RUNTIME_OUTPUT_DIRECTORY "${PYTHON_OUTPUT_DIR}"
      LIBRARY_OUTPUT_DIRECTORY "${PYTHON_OUTPUT_DIR}"
      ARCHIVE DESTINATION "${PLM_INSTALL_LIB_DIR}"
      PUBLIC_HEADER DESTINATION "${PLM_INSTALL_INCLUDE_DIR}"
      )
  endif ()
endif ()

=== src/cli/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_cli)

include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
include_directories (AFTER ${LUA_INCLUDE_DIR})

##-----------------------------------------------------------------------------
##  SOURCE FILES
##-----------------------------------------------------------------------------
#set (PLMCLP_LIBRARY_SRC
#  plm_clp.cxx plm_clp.h
#  )

set (PLASTIMATCH_SRC
  pcmd_add.cxx 
  pcmd_adjust.cxx 
  pcmd_autolabel_train.cxx 
  pcmd_autolabel.cxx 
  pcmd_bbox.cxx pcmd_bbox.h
  pcmd_benchmark.cxx 
  pcmd_boundary.cxx pcmd_boundary.h
  pcmd_compare.cxx 
  pcmd_compose.cxx 
  pcmd_crop.cxx 
  pcmd_dice.cxx 
  pcmd_diff.cxx 
  pcmd_dmap.cxx
  pcmd_dose.cxx pcmd_dose.h
  pcmd_drr.cxx 
  pcmd_dvh.cxx 
  pcmd_fdk.cxx 
  pcmd_filter.cxx
  pcmd_gamma.cxx
  pcmd_header.cxx
  pcmd_intersect.cxx
  pcmd_jacobian.cxx
  pcmd_lm_warp.cxx
  pcmd_mabs.cxx 
  pcmd_mask.cxx 
  pcmd_maximum.cxx
  pcmd_ml_convert.cxx pcmd_ml_convert.h 
  pcmd_multiply.cxx
  pcmd_probe.cxx 
  pcmd_register.cxx pcmd_register.h 
  pcmd_resample.cxx 
  pcmd_scale.cxx
#  pcmd_script.cxx 
  pcmd_segment.cxx 
  pcmd_sift.cxx
  pcmd_stats.cxx 
  pcmd_synth.cxx 
  pcmd_synth_vf.cxx 
  pcmd_threshold.cxx
  pcmd_thumbnail.cxx 
  pcmd_union.cxx
  pcmd_warp.cxx 
  pcmd_warp_dij.cxx 
  pcmd_warp_pointset.cxx 
  pcmd_wed.cxx pcmd_wed.h
  pcmd_xio_dvh.cxx 
  pcmd_xf_convert.cxx 
  pcmd_xf_invert.cxx pcmd_xf_invert.h
  plastimatch_main.cxx
  plastimatch_startup.cxx
  )

set (LANDMARK_WARP_SRC
  landmark_warp_main.cxx
  )

set (DRR_SRC
  drr_main.cxx 
  drr_opts.cxx
  )

set (PLM_CLI_LIBRARIES ${PLASTIMATCH_LIBS} plmclp)

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
plm_add_executable_v3 (plastimatch
  "${PLASTIMATCH_SRC}"
  "${PLASTIMATCH_INCLUDE_DIRECTORIES}"
  "${PLM_CLI_LIBRARIES}"
  "${PLASTIMATCH_LDFLAGS}"
  ${INSTALL_ALWAYS})

=== src/clp/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_clp)

##-----------------------------------------------------------------------------
##  SOURCE FILES
##-----------------------------------------------------------------------------
set (PLMCLP_LIBRARY_SRC
  plm_clp.cxx plm_clp.h
  )

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
plm_add_static_library (
  plmclp
  "${PLMCLP_LIBRARY_SRC}"
  ""
  ""
  ""
)
target_include_directories (plmclp 
	PRIVATE 
	"${DLIB_INCLUDE_DIRS}"
	"${PLM_SOURCE_DIR}/src/sys"
	"${PLM_BINARY_DIR}"
	)

=== src/cuda/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_cuda)

set_directory_properties (PROPERTIES INCLUDE_DIRECTORIES "")
set_directory_properties (PROPERTIES COMPILE_DEFINITIONS "")

include_directories (BEFORE ${PLM_BINARY_DIR})
include_directories (BEFORE ${CMAKE_SOURCE_DIR}/src/base)
include_directories (BEFORE ${CMAKE_SOURCE_DIR}/src/cuda)
include_directories (BEFORE ${CMAKE_SOURCE_DIR}/src/register)
include_directories (BEFORE ${CMAKE_SOURCE_DIR}/src/sys)
include_directories (BEFORE ${CMAKE_SOURCE_DIR}/src/util)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
include_directories (AFTER ${MSINTTYPES_INCLUDE_DIR})

##-----------------------------------------------------------------------------
##  SOURCE FILES
##-----------------------------------------------------------------------------
set (PLMCUDA_LIBRARY_SRC
  cuda_kernel_util.cu
  cuda_mem.cu
  cuda_probe.cu
  cuda_texture.cu
  cuda_util.cu
  )

##-----------------------------------------------------------------------------
##  LIBRARY DEPENDENCIES
##-----------------------------------------------------------------------------
set (PLMCUDA_LIBRARY_DEPENDENCIES 
  plmsys
  ${CUDA_LIBRARIES}
  )

##-----------------------------------------------------------------------------
##  SPECIAL BUILD RULES: CUDA
##-----------------------------------------------------------------------------
if (CUDA_FOUND)
  if (PLM_USE_GPU_PLUGINS)
    plm_add_gpu_plugin_library (plmcuda "${PLMCUDA_LIBRARY_SRC}")
    target_link_libraries (plmcuda
      ${PLMCUDA_LIBRARY_DEPENDENCIES}
      )
  else ()
    cuda_compile (CUDA_WRAPPERS ${PLMCUDA_LIBRARY_SRC})
    set (PLMCUDA_LIBRARY_SRC
      ${PLMCUDA_LIBRARY_SRC}
      ${CUDA_WRAPPERS}
      )
    plm_add_library (
      plmcuda
      "${PLMCUDA_LIBRARY_SRC}" 
      "${PLMCUDA_LIBRARY_DEPENDENCIES}"
      ""
      "${PLASTIMATCH_INCLUDE_DIRECTORIES}"
      "")
  endif ()
endif ()

=== src/dose/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_dose)

include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})

##-----------------------------------------------------------------------------
##  SOURCE FILES
##-----------------------------------------------------------------------------
set (PLMDOSE_LIBRARY_SRC
  beam_calc.cxx beam_calc.h
  beam_map.cxx beam_map.h
  bragg_curve.cxx bragg_curve.h
  compute_dose.cxx compute_dose.h
  dose_volume_functions.cxx dose_volume_functions.h
  particle_type.cxx particle_type.h
  rt_beam_model.cxx rt_beam_model.h
  rt_depth_dose.cxx rt_depth_dose.h
  rt_dij.cxx rt_dij.h
  rt_dose_timing.h
  rt_lut.cxx rt_lut.h
  rt_spot_map.cxx rt_spot_map.h
  rt_mebs.cxx rt_mebs.h
  rt_parms.cxx rt_parms.h
  plan_calc.cxx plan_calc.h
  rt_sigma.cxx rt_sigma.h
  wed_parms.cxx wed_parms.h
  )

set (PLMDOSE_LIBRARY_DEPENDENCIES 
  plmbase
  plmutil
  plmsys
  )

set (PLMDOSE_LIBRARY_DEPENDENCIES 
  ${PLMDOSE_LIBRARY_DEPENDENCIES} 
  specfun)

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
plm_add_library (
  plmdose
  "${PLMDOSE_LIBRARY_SRC}" 
  "${PLMDOSE_LIBRARY_DEPENDENCIES}"
  ""
  "${PLASTIMATCH_INCLUDE_DIRECTORIES}"
  "")

=== src/opencl/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_opencl)

include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})

set (PLMOPENCL_LIBRARY_SRC
  opencl_util.cxx
  )

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
if (OpenCL_FOUND)
  set (PLMOPENCL_LIBRARY_DEPENDENCIES
    plmsys
    ${OpenCL_LIBRARIES}
    )
  plm_add_library (
    plmopencl
    "${PLMOPENCL_LIBRARY_SRC}" 
    "${PLMOPENCL_LIBRARY_DEPENDENCIES}"
    "${PLMOPENCL_LIBRARY_LDFLAGS}"
    "${PLASTIMATCH_INCLUDE_DIRECTORIES}"
    "")
endif ()

=== src/qt/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_qt)

include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
include_directories (BEFORE ${CMAKE_CURRENT_BINARY_DIR})

if (QT4_FOUND)
  set (QT4_INCLUDE_DIRS ${QT_QTGUI_INCLUDE_DIR}
    ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR})
  set (QT4_LIBRARIES ${QT_QTGUI_LIBRARY} ${QT_QTCORE_LIBRARY})
endif ()

##-----------------------------------------------------------------------------
##  SOURCE FILES
##-----------------------------------------------------------------------------
set (PLASTIMATCH_QT_SRC
  # pqt_application.cxx pqt_application.h
  pqt_data_source_dialog.cxx pqt_data_source_dialog.h
  pqt_data_source_list_model.cxx pqt_data_source_list_model.h
  pqt_database.cxx pqt_database.h
  pqt_findscu.cxx pqt_findscu.h
  pqt_main.cxx
  pqt_main_window.cxx pqt_main_window.h
  pqt_patient_list_model.cxx pqt_patient_list_model.h
  )

set (CRYSTALVIEW_SRC
  cview_portal.cxx cview_portal.h
  cview_main.cxx cview_main.h
  )

if (PLM_CONFIG_BUILD_QT_PLUGINS)
  set (QT_DESIGNER_PLUGINS_SRC
    cview_portal.cxx cview_portal.h
    cview_portal_plugin.cxx cview_portal_plugin.h
    )
endif()

##-----------------------------------------------------------------------------
##  SPECIAL BUILD RULES: Qt
##-----------------------------------------------------------------------------
if (QT4_FOUND)
  qt4_wrap_cpp (PORTAL_MOC_SRC
    cview_portal.h
    )
  qt4_wrap_cpp (CRYSTALVIEW_MOC_SRC
    cview_main.h
    )
  if (PLM_CONFIG_BUILD_QT_PLUGINS)
    qt4_wrap_cpp (QT_DESIGNER_PLUGINS_MOC_SRC
      cview_portal.h
      cview_portal_plugin.h
    )
  endif()
  set (CRYSTALVIEW_SRC
    ${CRYSTALVIEW_SRC}
    ${CRYSTALVIEW_MOC_SRC}
    ${PORTAL_MOC_SRC}
    )

  if (QT_QTSQL_FOUND)
    qt4_wrap_cpp (PLASTIMATCH_QT_SRC 
      #    pqt_application.h
      pqt_data_source_dialog.h
      pqt_data_source_list_model.h
      pqt_main_window.h 
      pqt_patient_list_model.h
      )
    qt4_wrap_ui (PLASTIMATCH_QT_SRC 
      pqt_data_source_dialog.ui
      pqt_main_window.ui
      )
  endif ()
endif ()

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
if (ITK_FOUND AND QT4_FOUND)
  set (CRYSTALVIEW_LIBRARIES ${PLASTIMATCH_LIBS} 
    ${QT_QTSQL_LIBRARIES} ${QT4_LIBRARIES})
  plm_add_executable_v3 (cview "${CRYSTALVIEW_SRC}"
    "${QT4_INCLUDE_DIRS}" "${CRYSTALVIEW_LIBRARIES}"
    "${PLASTIMATCH_LDFLAGS}" ${INSTALL_IF_NOT_DEBIAN})
endif ()
if (ITK_FOUND AND QT4_FOUND AND QT_QTSQL_FOUND)
  if (PLM_CONFIG_ENABLE_PLASTIMATCH_QT)
    set (PLASTIMATCH_QT_LIBRARIES ${PLASTIMATCH_LIBS} 
      ${QT_QTSQL_LIBRARIES} ${QT4_LIBRARIES})
    plm_add_executable_v3 (plastimatch_qt "${PLASTIMATCH_QT_SRC}"
      "${QT4_INCLUDE_DIRS}" "${PLASTIMATCH_QT_LIBRARIES}" 
      "${PLASTIMATCH_LDFLAGS}" ${INSTALL_IF_NOT_DEBIAN})
  endif ()
endif ()

##-----------------------------------------------------------------------------
##  BUILD QT DESIGNER PLUGINS
##-----------------------------------------------------------------------------
if (PLM_CONFIG_BUILD_QT_PLUGINS)
  add_definitions(-DQT_PLUGIN)
  add_definitions(-DQT_NO_DEBUG)
  add_definitions(-DQT_SHARED)
  add_definitions(-DQDESIGNER_EXPORT_WIDGETS)
  
  add_library(cview_portal_plugin SHARED
      ${QT_DESIGNER_PLUGINS_SRC}
      ${QT_DESIGNER_PLUGINS_MOC_SRC}
  )
  set (QT_DESIGNER_PLUGINS_LIBRARIES ${PLASTIMATCH_LIBS} ${QT_LIBRARIES})
  target_link_libraries(cview_portal_plugin ${QT_DESIGNER_PLUGINS_LIBRARIES})
  
  set_target_properties (cview_portal_plugin PROPERTIES
      LIBRARY_OUTPUT_DIRECTORY designer)

  install (TARGETS cview_portal_plugin 
#      DESTINATION ${QT_PLUGINS_DIR}/designer
      DESTINATION ${PLM_INSTALL_LIB_DIR}/designer)

endif()

=== src/reconstruct/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_reconstruct)

include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})

if (CUDA_FOUND)
  add_subdirectory (cuda)
  include_directories (BEFORE "${CMAKE_CURRENT_SOURCE_DIR}/cuda")
endif ()

##-----------------------------------------------------------------------------
##  SOURCE FILES
##-----------------------------------------------------------------------------
set (PLMRECONSTRUCT_LIBRARY_SRC
  bowtie_correction.cxx
  drr.cxx drr.h
  drr_options.cxx drr_options.h
  drr_trilin.cxx
  fdk.cxx
  fdk_util.cxx
  )
if (OPENCL_FOUND)
  set (PLMRECONSTRUCT_LIBRARY_SRC
    ${PLMRECONSTRUCT_LIBRARY_SRC}
    drr_opencl.cxx
    fdk_opencl.cxx
   )
endif ()

##-----------------------------------------------------------------------------
##  LIBRARY DEPENDENCIES
##-----------------------------------------------------------------------------
set (PLMRECONSTRUCT_LIBRARY_DEPENDENCIES 
  plmutil
  plmbase
  plmsys
  )
if (CUDA_FOUND)
  set (PLMRECONSTRUCT_LIBRARY_DEPENDENCIES 
    ${PLMRECONSTRUCT_LIBRARY_DEPENDENCIES}
    plmcuda
    )
  set (PLMRECONSTRUCT_LIBRARY_DEPENDENCIES 
    ${PLMRECONSTRUCT_LIBRARY_DEPENDENCIES}
    plmreconstructcuda
    )
endif ()
if (OPENCL_FOUND)
  set (PLMRECONSTRUCT_LIBRARY_DEPENDENCIES 
    ${PLMRECONSTRUCT_LIBRARY_DEPENDENCIES}
    plmopencl
    )
endif ()

##-----------------------------------------------------------------------------
##  SPECIAL BUILD RULES: OpenMP
##-----------------------------------------------------------------------------
if (OPENMP_FOUND)
  set (PLMRECONSTRUCT_LIBRARY_LDFLAGS "${OPENMP_LDFLAGS}")
  set_source_files_properties (drr.cxx
    PROPERTIES COMPILE_FLAGS ${OPENMP_FLAGS})
  set_source_files_properties (fdk.cxx
    PROPERTIES COMPILE_FLAGS ${OPENMP_FLAGS})
endif ()

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
plm_add_library (
  plmreconstruct
  "${PLMRECONSTRUCT_LIBRARY_SRC}" 
  "${PLMRECONSTRUCT_LIBRARY_DEPENDENCIES}"
  "${PLMRECONSTRUCT_LIBRARY_LDFLAGS}"
  "${PLASTIMATCH_INCLUDE_DIRECTORIES}"
  "")


if (CUDA_FOUND)
#  if (PLM_USE_GPU_PLUGINS)
    # because plmreconstructcuda is dynamically loaded (not linked)
    # CMake needs to be told explicitly that plmreconstruct
    # depends on it, so we tell it explicitly here
    add_dependencies (plmreconstruct plmreconstructcuda)
#  endif ()
endif ()

=== debian/changelog ===
plastimatch (1.10.0+dfsg.1-1) unstable; urgency=medium

  * [8e67811] New upstream version 1.10.0+dfsg.1
  * [f037548] Remove obsolete patches

 -- Steve M. Robbins <smr@debian.org>  Wed, 12 Feb 2025 22:48:49 -0600

plastimatch (1.9.4+dfsg.1-3) unstable; urgency=medium

  * Team upload
  * Removing obsolete RTSTRUCT DICOM tags to build against DCMTK/3.6.8
    (Closes: #1075793)
  * Raising Standards version to 4.7.0 (no change)
  * Fixing d/watch file after change in Gitlab's layout

 -- Pierre Gruet <pgt@debian.org>  Fri, 26 Jul 2024 10:31:35 +0200

plastimatch (1.9.4+dfsg.1-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [1932578] Build using C++17 (required for dcmtk).  Closes: #1039903.

 -- Steve M. Robbins <smr@debian.org>  Thu, 29 Jun 2023 11:38:50 -0500

=== debian/control ===
Source: plastimatch
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Gregory C. Sharp <gregsharp.geo@yahoo.com>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libblas-dev,
               libcharls-dev,
               libdcmtk-dev,
               libdlib-dev,
               libfftw3-dev,
               libgdcm-dev,
               libinsighttoolkit5-dev,
               liblapack-dev,
               libpng-dev,
               libsqlite3-dev,
               libtiff-dev,
               uuid-dev,
               zlib1g-dev,
               debhelper
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/plastimatch
Vcs-Git: https://salsa.debian.org/med-team/plastimatch.git
Homepage: https://plastimatch.org
Rules-Requires-Root: no

Package: plastimatch
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: medical image reconstruction and registration
 Plastimatch is an open source software for deformable image
 registration. It is designed for high-performance volumetric
 registration of medical images, such as X-ray computed tomography (CT),
 magnetic resonance imaging (MRI), and positron emission tomography(PET).
 Software features include:
  * B-spline method for deformable image registration (GPU and multicore
    accelerated), including support for image masking, landmark penalties,
    and regularization
  * Demons method for deformable image registration (GPU accelerated)
  * Multi-atlas segmentation
  * ITK-based algorithms for translation, rigid, affine, multiple demons
    methods, and B-spline registration
  * Pipelined, multi-stage registration framework with seamless conversion
    between most algorithms and transform types
  * Landmark-based deformable registration using thinplate splines for
    global registration
  * Landmark-based deformable registration using radial basis functions
    for local corrections
  * Broad support for 3D image file formats (using ITK), including DICOM,
    Nifti, NRRD, MetaImage, and Analyze
  * Extensive toolchain for radiotherapy research, including support for
    DICOM, DICOM-RT, DICOM SRO, XiO file format, gamma analysis, contour
    manipulation, contour overlap analysis, and vector field analysis
 Plastimatch also features two handy utilities which are not directly
 related to image registration:
  * FDK cone-beam CT reconstruction (GPU and multicore accelerated)
  * Digitally reconstructed radiograph (DRR) generation (GPU and multicore
    accelerated)

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

PACKAGE   = $(shell dh_listpackages)
TMP       = $(CURDIR)/debian/$(PACKAGE)

BUILD_DIR := obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(CURDIR)/$(BUILD_DIR):$(TMP)/usr/lib
export LD_LIBRARY_PATH

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

DEB_CMAKE_EXTRA_FLAGS += \
	-DCMAKE_CXX_STANDARD=17 \
        -DCMAKE_BUILD_TYPE:STRING=RELEASE \
        -DCMAKE_SKIP_RPATH:BOOL=ON \
        -DPLM_CONFIG_DEBIAN_BUILD:BOOL=ON \
        -DBUILD_SHARED_LIBS=ON \
        -DBUILD_TESTING:BOOL=ON

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#Make the test suit fatal on supported arches
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386 kfreebsd-amd64 kfreebsd-amd64))
	dh_auto_test
else
	dh_auto_test || true
endif
endif

override_dh_auto_install:
	dh_auto_install
	rm -rfv $(TMP)/usr/lib/*.a
	rm -rfv $(TMP)/usr/lib/cmake
	rm -rfv $(TMP)/usr/include
